package expressionPredictor;

//import util.MessageBoard;
//import util.HelpNote;
//import genomeCellGrowth.*;
//import util.VennDiagram;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
import javax.swing.*;
import java.io.*;
import java.awt.image.*;
import java.sql.*;
import java.util.zip.*;
import javax.swing.border.*;
import java.util.Random;
//import org.biomage.tools.xmlutils.MAGEReader;
//import org.biomage.Common.MAGEJava;

//import images.*;
import myutility.statistics.*;
import myutility.misc.*;
import myutility.io.*;
import myutility.plot2D.*;
//import normalization.*;
//import analysis.sequenceAnalysis.*;
//import mapsDatabase.*;
//import mapsDatabase.XML.*;
import datatable.*;
import java.net.URL;
import java.text.DateFormat;
import java.net.MalformedURLException;
import myutility.numerical.*;
//import analysis.massspectra.*;
//import affy.*;
/**
 * <p>Title: Gene Expression Dependence Extraction</p>
 * <p>Description: This is a software applied to gene expression profiles to extract gene expression dependence on treatments, agents, doses, times, etc.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: NIEHS</p>
 * @author Jeff Chou
 * @version 1.0
 */

public class ExpressionPridictorFrame extends JFrame {
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel_versionInfo = new JPanel();
  private MessageBoard msg;
  private boolean validConnection;
  protected Connection con = null;
//  protected SVNDataset [] QRH;
//  protected SVNDataset qrh;
//  private String version,smallImage,logoImage;
  private String version;
  private Vector [] dataHolder;

  private JPanel jPanel_logo;
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private JLabel jLabel_niehs = new JLabel();
  private JLabel jLabel_nmcGroup = new JLabel();
  private JLabel jLabel_version = new JLabel();
  private JLabel jLabel_predictor = new JLabel();
  private JLabel jLabel_exp = new JLabel();
  private GridBagLayout gridBagLayout2 = new GridBagLayout();
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenu1 = new JMenu();
  private JMenu jMenu3 = new JMenu();
  private JMenuItem jMenuItem_exit = new JMenuItem();
//  private JMenu jMenu4 = new JMenu();
  private JMenuItem jMenuItem_vennDiagram = new JMenuItem();
  private JMenuItem jMenuItem_help = new JMenuItem();
  private TitledBorder titledBorder1;
  private TitledBorder titledBorder2;
  private JButton jButton_logRatio = new JButton();
  private JButton jButton_intensity = new JButton();
  private JPanel jPanel2 = new JPanel();
  private JButton jButton_generic = new JButton();
  private GridBagLayout gridBagLayout4 = new GridBagLayout();
  private JButton jButton_mageml = new JButton();
  private JCheckBoxMenuItem jCheckBoxMenuItem_mageFileValidate = new JCheckBoxMenuItem();
  private JMenuItem jMenuItem_gc = new JMenuItem();
//  DataPlot new DataPlot(_msg)
   private   DataPlot dataPlot;
  private JCheckBoxMenuItem jCheckBoxMenuItem_megaDataSet = new JCheckBoxMenuItem();
//  private JMenuItem jMenuItem_affy_write_chp = new JMenuItem();
  private JMenuItem jMenuItem_simulationData = new JMenuItem();
  private JMenuItem jMenuItem_load_TF_gene_matrix = new JMenuItem();
  private JCheckBoxMenuItem jCheckBoxMenuItem_affyDatamerge = new JCheckBoxMenuItem();
  private JCheckBoxMenuItem jCheckBoxMenuItem_genomecellgrowth = new JCheckBoxMenuItem();
  private JMenuItem jMenuItem_load_fileNameMapping = new JMenuItem();
  private JMenuItem jMenuItem_loadFileNameCahnge = new JMenuItem();
  Properties fileNameMapping;
  private JMenuItem jMenuItem_getFileName = new JMenuItem();

  public ExpressionPridictorFrame() throws HeadlessException {

  //  File  f = FileIO.openSingleFile();
//    if (f == null ) return;
 //   readexcel(f.getName());



    FileIO.expressionPredictor = expressionPredictor.ExpressionPridictorFrame.class.getResource("expressionPredictor.txt");
    FileIO.imageIconURL = expressionPredictor.ExpressionPridictorFrame.class.getResource("smallExPLogo.gif");

     StringTokenizer p = new StringTokenizer((FileIO.imageIconURL).toString(),"/");
     int num =p.countTokens();

     String [] s = new String[num];
     int i=0;
     while(p.hasMoreTokens()) {
       s[i] =  p.nextToken();
       i++;
     }

     FileIO.docPath="";
     for (int k=1;k<s.length-3;k++)
       FileIO.docPath+=FileIO.removeChar(s[k])+"\\";
    FileIO.imageIcon = new ImageIcon(FileIO.imageIconURL);
    FileIO.logoImageURL = expressionPredictor.ExpressionPridictorFrame.class.getResource("largeExPLogo.gif");
    FileIO.backgroundImageURL = expressionPredictor.ExpressionPridictorFrame.class.getResource("whiteBackground.jpg");
    setIconImage(FileIO.imageIcon.getImage());
    jPanel_logo = new BackgroundPanel(FileIO.logoImageURL);

    version = "Version 1.1 August 1, 2006";
    jLabel_version.setText(version);

    msg = new MessageBoard();
    msg.setVisible(true);
    exitConfirm();
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    dataPlot = new DataPlot(msg);
  }
  public Image readImage(URL imageName){
    Image image = Toolkit.getDefaultToolkit().getImage(imageName);
    MediaTracker imageTracker = new MediaTracker(this);
    imageTracker.addImage(image, 0);
    try{
        imageTracker.waitForID(0);
    }catch(InterruptedException e){ return null;}
    return image;
}

  private void exitConfirm() {
      setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
      WindowListener l = new WindowAdapter() {
          public void windowClosing(WindowEvent e) {
              int confirm = JOptionPane.showConfirmDialog(null,
              "Really Exit?", "Exit Confirmation",
              JOptionPane.YES_NO_OPTION);
              if (confirm == 0) {
                  dispose();
                  System.exit(0);
              }
          }
      };
      addWindowListener(l);
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Connect to ArrayDB/MAPS Database");
    titledBorder2 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Load Data");
    jPanel1.setLayout(gridBagLayout1);
    jPanel_logo.setPreferredSize(new Dimension(200, 220));
    jPanel_versionInfo.setPreferredSize(new Dimension(220, 270));
    jPanel_versionInfo.setLayout(gridBagLayout2);
    jPanel1.setPreferredSize(new Dimension(450, 300));
    jLabel_niehs.setForeground(Color.red);
    jLabel_niehs.setPreferredSize(new Dimension(250, 50));
    jLabel_niehs.setText("National Center of Toxicogenomics");
    jLabel_nmcGroup.setFont(new java.awt.Font("Dialog", 0, 14));
    jLabel_nmcGroup.setForeground(Color.red);
    jLabel_nmcGroup.setPreferredSize(new Dimension(250, 50));
    jLabel_nmcGroup.setText("NIEHS Microarray Group");
    jLabel_version.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel_version.setForeground(Color.blue);
    jLabel_version.setPreferredSize(new Dimension(250, 50));
    jLabel_predictor.setFont(new java.awt.Font("Dialog", 0, 36));
    jLabel_predictor.setForeground(Color.blue);
    jLabel_predictor.setPreferredSize(new Dimension(250, 50));
    jLabel_predictor.setText("Predictor");
    jLabel_exp.setFont(new java.awt.Font("Dialog", 0, 36));
    jLabel_exp.setForeground(Color.blue);
    jLabel_exp.setPreferredSize(new Dimension(250, 50));
    jLabel_exp.setText("Expression");
    jButton_logRatio.setText("Compiled Expression");
    jButton_logRatio.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_logRatio_actionPerformed(e);
      }
    });
    jButton_intensity.setForeground(Color.lightGray);
    jButton_intensity.setPreferredSize(new Dimension(180, 25));
    jButton_intensity.setToolTipText("");
    jButton_intensity.setText("SVN Normalization");
    jButton_intensity.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_intensity_actionPerformed(e);
      }
    });
    jPanel2.setBorder(titledBorder2);
    jPanel2.setLayout(gridBagLayout4);
    jButton_generic.setForeground(Color.lightGray);
    jButton_generic.setPreferredSize(new Dimension(180, 25));
    jButton_generic.setText("Generic Intensity Files");
    jButton_generic.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_generic_actionPerformed(e);
      }
    });
    jMenu1.setText("File");
//    jMenu4.setText("Utility");
    jMenu3.setText("Help");
    jMenuItem_exit.setText("Exit");
    jMenuItem_exit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_exit_actionPerformed(e);
      }
    });
    jMenuItem_vennDiagram.setText("Venn Diagram");
    jMenuItem_vennDiagram.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
  //      jMenuItem_vennDiagram_actionPerformed(e);
      }
    });
    jMenuItem_help.setText("Help");
    jMenuItem_help.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_help_actionPerformed(e);
      }
    });
    jButton_mageml.setForeground(Color.lightGray);
    jButton_mageml.setRequestFocusEnabled(false);
    jButton_mageml.setSelected(true);
    jButton_mageml.setText("Affy Data Conversion");
    jButton_mageml.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_mageml_actionPerformed(e);
      }
    });

    jCheckBoxMenuItem_mageFileValidate.setText("MAGE file validate");
    jMenuItem_gc.setText("Clear Memory");
    jMenuItem_gc.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_gc_actionPerformed(e);
      }
    });
    this.setResizable(false);
    this.setTitle("Expression Predictor");
    jCheckBoxMenuItem_megaDataSet.setText("Mega Intensity Data Sets");
 //   jMenuItem_affy_write_chp.setText("Affy Write Chp");
 //   jMenuItem_affy_write_chp.addActionListener(new java.awt.event.ActionListener() {
 //     public void actionPerformed(ActionEvent e) {
 //       jMenuItem_affy_write_chp_actionPerformed(e);
 //     }
 //   });
    jMenuItem_simulationData.setText("Simulation Data");
    jMenuItem_simulationData.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_simulationData_actionPerformed(e);
      }
    });
    jMenuItem_load_TF_gene_matrix.setText("Load Gene-TF Matrix");
    jMenuItem_load_TF_gene_matrix.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_load_TF_gene_matrix_actionPerformed(e);
      }
    });
    jCheckBoxMenuItem_affyDatamerge.setText("AffyDataMerge");
    jCheckBoxMenuItem_genomecellgrowth.setText("Gemone-wide cell growth");
    jMenuItem_load_fileNameMapping.setText("Load File Name Mapping File");
    jMenuItem_load_fileNameMapping.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_load_fileNameMapping_actionPerformed(e);
      }
    });
    jMenuItem_loadFileNameCahnge.setText("Load Files For Name Change");
    jMenuItem_loadFileNameCahnge.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_loadFileName_rename_actionPerformed(e);
      }
    });
    jMenuItem_getFileName.setText("Get File Name");
    jMenuItem_getFileName.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_getFileName_actionPerformed(e);
      }
    });
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel_logo,        new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 3, 3), 0, 0));
    jPanel1.add(jPanel_versionInfo,       new GridBagConstraints(1, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));
    jPanel_versionInfo.add(jLabel_exp,          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel_versionInfo.add(jLabel_predictor,       new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel_versionInfo.add(jLabel_version,     new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel_versionInfo.add(jLabel_nmcGroup,   new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel_versionInfo.add(jLabel_niehs,  new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jPanel2,     new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton_intensity,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton_logRatio,    new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton_mageml, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton_generic,  new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
    jMenuBar1.add(jMenu1);
 //   jMenuBar1.add(jMenu4);
    jMenuBar1.add(jMenu3);
    jMenu1.add(jMenuItem_loadFileNameCahnge);
    jMenu1.add(jMenuItem_load_fileNameMapping);
    jMenu1.add(jMenuItem_getFileName);
    jMenu1.add(jMenuItem_exit);
  //  jMenu4.add(jMenuItem_vennDiagram);
  //  jMenu4.add(jCheckBoxMenuItem_mageFileValidate);
  //  jMenu4.add(jMenuItem_gc);
  //  jMenu4.add(jCheckBoxMenuItem_megaDataSet);
  //  jMenu4.add(jMenuItem_affy_write_chp);
  //  jMenu4.add(jMenuItem_simulationData);
  //  jMenu4.add(jMenuItem_load_TF_gene_matrix);
  //  jMenu4.add(jCheckBoxMenuItem_affyDatamerge);
  //  jMenu4.add(jCheckBoxMenuItem_genomecellgrowth);
    jMenu3.add(jMenuItem_help);
    setJMenuBar(jMenuBar1);
    setBounds(0, 0, 440, 400);
  }
  private String getConnection(String serverName, String userName, String psword) {

      String url;
      try {
          Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      }
      catch (ClassNotFoundException cnfe) {
          cnfe.printStackTrace();
          msg.messageDisplay("class not found.\n");
          return "sun.jdbc.odbc.JdbcOdbcDriver not found.";
      }

      url = "jdbc:odbc:" + serverName;
      String str = "";
      try {
          con = DriverManager.getConnection (url, userName, psword);
          DatabaseMetaData dma = con.getMetaData ();
          str += "Connected to " + dma.getURL();
          str += "\nDriver " + dma.getDriverName();
          str += "\nVersion " + dma.getDriverVersion() + "\n";
          msg.messageDisplay(str +"\n\n");
      }
      catch (SQLException ex) {
          while (ex != null) {
              str += "SQLState: " + ex.getSQLState ();
              str += "\n" + ex.getMessage() + "\n";
              ex = ex.getNextException ();
          }
          return str;
      }

      if(con != null)return "connected";
      else  return "connection is failed.";

 //   return null;
  }




  void jMenuItem_exit_actionPerformed(ActionEvent e) {
     System.exit(0);
  }

//  void jMenuItem_vennDiagram_actionPerformed(ActionEvent e) {
//    VennDiagram vd = new VennDiagram();
//    String s= vd.loadData();
//    vd.vennDiagram();
//  }

  void jButton_mageml_actionPerformed(ActionEvent e) {
    /*
   if(jCheckBoxMenuItem_affyDatamerge.isSelected()){
     new Afft_probe_pm_mm_merge().setVisible(true);
   }
     else {
    File f = FileIO.openSingleFile();
    if (f == null ) {
      return;
    }
    new AffyDataFrame(f,msg,dataPlot).setVisible(true);
     }
     */
//    File [] f = FileIO.openMultiFiles(false);
//    new MassSpectraAnalysisFrame(f,msg).show();
//    new SequenceAnalysisFrame(msg,dataPlot);
  }
  void jButton_logRatio_actionPerformed(ActionEvent e) {
    File f = FileIO.openSingleFile();
    if (f == null ) {
      return;
    }
    String extension = MyFileFilter.getExtension(f);
    new GenericCompiledDataFrameIO(f,extension,msg,dataPlot).setVisible(true);
  }

  void jButton_intensity_actionPerformed(ActionEvent e) {
 //   new SVN(msg,dataPlot).show();

/*
    File [] f = FileIO.openMultiFiles(true);
    if (f == null ) return;

    new SVNFrame(f, msg,dataPlot,jCheckBoxMenuItem_megaDataSet.isSelected());
    */
  }

  void jButton_generic_actionPerformed(ActionEvent e) {
    /*
    if (jCheckBoxMenuItem_genomecellgrowth.isSelected())
      new genomeCellGrowthMain(msg,dataPlot).setVisible(true);
     else {

    File [] f = FileIO.openMultiFiles(true);
    if (f == null ) return;
    String extension = MyFileFilter.getExtension(f[0]);
    new GenericIntensityDataSetsFrameIO(f,extension,msg,dataPlot).setVisible(true);
     }
    */
  }

  void jMenuItem_gc_actionPerformed(ActionEvent e) {
    System.gc();
  }

  void jMenuItem_help_actionPerformed(ActionEvent e) {
    String ss = FileIO.docPath+"help\\expressionPredictor.pdf";
    FileIO.openPDF(ss);
  }

  void jMenuItem_affy_write_chp_actionPerformed(ActionEvent e) {
    File  f = FileIO.openSingleFile();
    if (f == null ) return;
//    new write_chp(f);

  }

  void jMenuItem_simulationData_actionPerformed(ActionEvent e) {
//    new simulationData(msg,dataPlot).setVisible(true);

  }
  void jMenuItem_load_TF_gene_matrix_actionPerformed(ActionEvent e) {
    File  f = FileIO.openSingleFile();
    if (f == null ) return;
    DataConversion.TF_gene_matrix(f,"\t");

  }
//  public static void main(String[] args) {
//    new ExpressionPridictorFrame().setVisible(true);
//    new ExpressionPridictorFrame().show();
//  }

  public static void main(String[] args) throws HeadlessException {
//    new ExpressionPridictorFrame().setVisible(true);
      new ExpressionPridictorFrame().setVisible(true);
  }

  public void readexel(String filename)


  {
  Connection c = null;
  Statement stmnt = null;
  try
  {
  Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
  c = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Excel Driver (*.xls)};DBQ=" + filename);
  stmnt = c.createStatement();
  String query = "Select * from [Sheet1$]" ;
  ResultSet rs = stmnt.executeQuery( query );

  while( rs.next() )
  {
  System.out.println( rs.getString(1) );
  }
  }
  catch( Exception e )
  {
  System.err.println( e );
  }


}

  public void readexcel(String filename) {
Connection c = null;
Statement stmnt = null;
try
{
Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
c = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Excel Driver (*.xls)};DBQ=" + filename);
stmnt = c.createStatement();
String query = "Select * from [Sheet1$]" ;
ResultSet rs = stmnt.executeQuery( query );
int colNum=0;
if (rs.next()) {
  ResultSetMetaData rsmd = rs.getMetaData();
  colNum = rsmd.getColumnCount();
  for (int i=1;i<= colNum;i++) {
    System.out.println("name "+rsmd.getColumnName(i));
  }
  for (int i=1;i<= colNum;i++)
    System.out.println( rs.getString(i) );

}
while( rs.next() )
{
  for (int i=1;i<= colNum;i++) {
    String str = rs.getString(i);
    if (str != null)
    System.out.println( str +"\t");
  }
  System.out.println( "" );
}
}
catch( Exception e )
{
System.err.println( e );
}
  }
  public void readcsv(String filename) {
    Connection c = null;
   Statement stmnt = null;
   try
   {
     System.out.println( "this" );
   Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
   System.out.println( "this2" );
   c = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Excel Driver (*.xls)};DBQ=" + filename);
//   c = DriverManager.getConnection("jdbc:odbc:surajtest");
//   c = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Excel Driver (*.txt;*.xls)};DBQ=" + filename);
//   c = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Text Driver (*.txt; *.csv)};DBQ=" + filename);
//   c = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Text-Treiber (*.txt; *.csv)};DBQ=" + filename);
   System.out.println( "this3" );
   stmnt = c.createStatement();
  System.out.println( "this4" );
//ResultSet rs = stmnt.executeQuery("select * from [test$]");
   String query = "Select * from [Sheet1$]" ;
   ResultSet rs = stmnt.executeQuery( query );
   System.out.println( "this5" );
//if (rs.isFirst())
//  System.out.println( rs.getString(1) );

//if (rs.first())
//    System.out.println( rs.getString(1) );
   int colNum=0;
   if (rs.next()) {
     ResultSetMetaData rsmd = rs.getMetaData();
     colNum = rsmd.getColumnCount();
     for (int i=1;i<= colNum;i++) {
       System.out.println("name "+rsmd.getColumnName(i));
     }
     for (int i=1;i<= colNum;i++)
       System.out.println( rs.getString(i) );

   }
   while( rs.next() )
   {
     for (int i=1;i<= colNum;i++) {
       String str = rs.getString(i);
       if (str != null)
       System.out.println( str +"\t");
     }
     System.out.println( "" );
   }
   }
   catch( Exception e )
   {
   System.err.println( e );
   }

  }

  void jMenuItem_loadFileName_rename_actionPerformed(ActionEvent ee) {
    if (fileNameMapping == null) return;
    File [] f = FileIO.openMultiFiles(true);
    if (f == null) return;
//    java.util.StringTokenizer token = new java.util.StringTokenizer(outputFile,"_");
//    String outputFile =  token.nextToken()+".txt";

    String inputFileName;
    String key,outputFileName;
    String extension = "";
   for (int i=0;i<f.length;i++) {
     inputFileName = f[i].getName();
     java.util.StringTokenizer token1 = new java.util.StringTokenizer(inputFileName,".");
     extension = token1.nextToken();
     extension = token1.nextToken();
     outputFileName = fileNameMapping.getProperty(inputFileName);
     if (outputFileName == null)
       System.out.print(inputFileName + " has no value found"+"\n");
       else {
      outputFileName += "."+extension;
      System.out.print(inputFileName + " has value "+outputFileName +"\n");

     try {

   FileWriter wrt = new FileWriter(new File(f[i].getParent(),outputFileName));
   PrintWriter out = new PrintWriter(wrt);
   FileReader reader = new FileReader(new File(f[i].getPath()));
   BufferedReader readIn = new BufferedReader(reader);
   while (readIn.ready()) {
     out.println(readIn.readLine());
   }
   readIn.close();
   reader.close();
   wrt.flush();
   wrt.close();

   }
   catch (FileNotFoundException e) {
     System.out.println("FileNotFoundException "+e.toString());
   }
   catch (IOException e) {
     System.out.println("IOException "+e.toString());
   }
   }
   }
  }

  void jMenuItem_load_fileNameMapping_actionPerformed(ActionEvent e) {
    File f = FileIO.openSingleFile();
    if (f == null) return;
    fileNameMapping = new Properties();
    String [][] str = FileIO.read_txt(f,"\t");
    String barcode_key, value;
    for (int i=0;i<str.length;i++) {
      barcode_key = str[i][0];
      value = "";
      if (str[i].length > 1)
      for (int j=1;j<str[i].length;j++) {
        if (j == str[i].length-1)
          value  += str[i][j];
        else
          value  += str[i][j]+"_";
      }
      fileNameMapping.setProperty(barcode_key,value);
      System.out.print(barcode_key+ " "+value +"\n");

    }
    System.out.println("file rename mapping loaded\n");

  }

  void jMenuItem_getFileName_actionPerformed(ActionEvent e) {
    File [] f = FileIO.openMultiFiles(true);
    if (f == null) return;
    try {

  FileWriter wrt = new FileWriter(new File(f[0].getParent(),"fileNameList.txt"));
  PrintWriter out = new PrintWriter(wrt);

  for (int i=0;i<f.length;i++) {
    out.println(f[i].getName());
  }
  wrt.flush();
  wrt.close();

  }
  catch (FileNotFoundException ee) {
    System.out.println("FileNotFoundException "+ee.toString());
  }
  catch (IOException ee) {
    System.out.println("IOException "+ee.toString());
  }

  }




}